#
# wallpaper-change 1.5.ps1
# Simple Wallpaper Change v1.5
#
# Pierre Wasser (p.wasser@samthammel.de)
# http://samthammel.de
#
# Lediglich die Optionen am Anfang dieser Datei durchgehen und auf eigene
# Bedrfnisse hin anpassen. Zustzlich wird nur Irfanview bentigt, das
# ist kostenlos.

# IrfanView ist downlaodbar unter
# http://www.irfanview.com/
#

###############################################################################
#Optionen zum Einstellen fangen hier an:
###############################################################################

Param
	(
	$iview = "c:\programme\irfanview\i_view32.exe",
	# Vollstndiger Pfad zu Irfanview

	$directory = "c:\Bilder",
	# Das Bildverzeichnis ohne "\" am Ende
	
	$extensions = ("*.jpg", "*.png", "*.bmp"),
	# Dateierweiterungen, die benutzt werden
	
	# Das von Irfanview erstellte Bild liegt brigens nachher unter %appdata%\Irfanview\
	
	$max_x = 1024,
	# Maximale Breite des Bildes, Seitenverhltnis wird automatisch eingehalten!
	
	$max_y = 768,
	# Maximale Hhe des Bildes, Seitenverhltnis wird automatisch eingehalten!
	
	$quality = 98,
	# JPG-Qualitt
	
	$sharpen = 20,
	# Wieviel nachschrfen (0-100)? Das ist wichtig, da bei Quellbildern mit
	# groer Auflsung die Schrfe durch die Grennderung teilweise arg
	# leidet

	$wall = 0
	# Anzeigemodus vom Hintergrundbild - 0=centered, 1=tiled, 2=stretched
	
	)

###############################################################################
# Und enden hier drber
###############################################################################
	
	
	
# Diverse Variablenzuweisungen, da ich aus Powershell nicht klug geworden bin, wann es einfache
# und doppelte Anfhrungszeichen nun weitergibt oder unterdrckt. Daher ein wenig umstndlicher.
# Wer eine einfachere Lsung hat, kann mir ja einen Tip per E-Mail geben. ;-)

$bmpfile = '/convert=' + "$bmpfile"
# Zielpfad fr das Hintergrundbild

$max_xy = '/resize=' + '(' + "$max_x" + ',' + "$max_y" + ')'
# Hier werden die Maxgren zusammengefgt

$quality = '/jpgq=' + $quality	
# Stellt der Qualitt den bentigen Parameter -q voran.

$sharpen = '/sharpen=' + $sharpen
# Nachschrfen der Bilder

$wall = '/wall=' + $wall
# Anzeigemodus des Hintergrundbildes
	
$files = get-childitem $directory -name:$true -include $extensions -recurse

if ($files.Length -le 0)
{
	write-host Error@No $extensions files in $directory
	return
}

$random = new-object System.Random

$index = $random.Next(0, $files.Length - 1)
$selectedbackground = '"' + $directory + "\" + $files[$index] + '"'
write-host $selectedbackground

# Der eigentliche Aufruf zur Konvertierung
&$iview $selectedbackground $max_xy /aspectratio /resample $sharpen $quality /killmesoftly $wall
